//
// Slave-main.c
// Team NAHVG
//


#include "basic_io.h"
#include "DM9000A.h"
#include <alt_types.h>
#include "alt_up_ps2_port.h"
#include "ps2_mouse.h"
#include "VGA.h"
#include <string.h>
#define IOWR_VGA_DATA(base, offset, data) \
IOWR_16DIRECT(base, (offset) * 2, data)
#define MAX_MSG_LENGTH 128


// Ethernet MAC address.  Choose the last three bytes yourself
unsigned char mac_address[6] = { 0x01, 0x60, 0x6E, 0x11, 0x01, 0x0E  };

unsigned int interrupt_number;

unsigned int receive_buffer_length;
unsigned char receive_buffer[1600];
unsigned long checksum;
int data_mouse;
int ctrl_mouse;
int bytes_mouse;
int data_reg1;
int puck_x = 320,puck_y = 232;


#define UDP_PACKET_PAYLOAD_OFFSET 42
#define UDP_PACKET_LENGTH_OFFSET 38

#define UDP_PACKET_PAYLOAD (transmit_buffer + UDP_PACKET_PAYLOAD_OFFSET)
unsigned char transmit_buffer[] = {
            // Ethernet MAC header
         0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, // Destination MAC address
         0x01, 0x60, 0x6E, 0x11, 0x01, 0x0E, // Source MAC address
         0x08, 0x00,
         // IP Header: bytes 14-33
         0x45,                // version (IPv4), header length = 20 bytes
         0x00,                // differentiated services field
         0x00,0x9C,           // total length: 20 bytes for IP header +
                              // 8 bytes for UDP header + 128 bytes for payload
         0x00, 0x35,          // packet ID
         0x00,                // flags
         0x00,                // fragment offset
         0x80,                // time-to-live
         0x11,                // protocol: 11 = UDP
         0x00,0x00,           // header checksum: incorrect
       
         0xc0,0xa8,0x01,0x01, // source IP address
         0xc0,0xa8,0x01,0xff, // destination IP address
// UDP Header : 8 bytes
         0x67,0xd9, // source port port (26585: garbage)????
         0x27,0x2b, // destination port (10027: garbage)????
         0x00,0x88, // length (136: 8 for UDP header + 128 for data)
         0x00,0x00, // checksum: 0 = none
         // UDP payload
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
         0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67     
     };




static void ethernet_interrupt_handler() {
    unsigned int receive_status;
    //printf("running ethernet interrupt routing\n");
    receive_status = ReceivePacket(receive_buffer, &receive_buffer_length);
    if (receive_status == DMFE_SUCCESS) {
       if (receive_buffer_length >= 14) {
            //  A real Ethernet packet
            //printf("len=%d 12 = %d 13=%d\n",receive_buffer_length,receive_buffer[12],receive_buffer[13]);
           if (receive_buffer[12]==8 && receive_buffer[13]==0 && receive_buffer_length>=34){
                // An IP packet
                if (receive_buffer[23] == 0x11) {
                    // A UDP packet
                    if (receive_buffer_length >= UDP_PACKET_PAYLOAD_OFFSET) {
                       IOWR_VGA_DATA(VGA_BASE, 2, receive_buffer[UDP_PACKET_PAYLOAD_OFFSET]);
                       int y = ((receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+2] << 8) & 0xffff) + receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+1];
                       IOWR_VGA_DATA(VGA_BASE, 3, y);
                       puck_x = ((receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+4] << 8) & 0xffff) + receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+3];
                       IOWR_VGA_DATA(VGA_BASE, 4, puck_x);
                       puck_y = ((receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+6] << 8) & 0xffff) + receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+5];
                       IOWR_VGA_DATA(VGA_BASE, 5, puck_y);
                       IOWR_VGA_DATA(VGA_BASE, 7, receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+7]);
                       IOWR_VGA_DATA(VGA_BASE, 8, receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+8]);
                      // printf("p1 = %d p2 = %d",receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+7],receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+8]);
                    }
               } else {
                  printf("Received non-UDP packet\n");
                 }
            } else {
                printf("Received non-IP packet\n");
              }
        } else {
            printf("Malformed Ethernet packet\n");
          }

    } else {
        printf("Error receiving packet\n");
      }

  // Display the number of interrupts on the LEDs 
  interrupt_number++;
  /
  //Clear the DM9000A ISR: PRS, PTS, ROS, ROOS 4 bits, by RW/C1 
  dm9000a_iow(ISR, 0x3F);
        
  // Re-enable DM9000A interrupts 
  dm9000a_iow(IMR, INTR_set);
}//end of interrupt handler

int main(){
        
 int user_x = 20 , user_y = 20;
 int prev_puck_x =0, prev_puck_y=0;
 
 int curMsgChar = 0;
 unsigned int packet_length=0;
  // Print a friendly welcome message
 printf("4840 Lab 2 started\n");

 // Initalize the DM9000 and the Ethernet interrupt handler
 DM9000_init(mac_address);
 interrupt_number = 0;
 
alt_irq_register(DM9000A_IRQ, NULL, (void*)ethernet_interrupt_handler);

 // Initialize the mouse
 printf("Please wait three seconds to initialize mouse\n");
 clear_FIFO(); //clear for PS2 device
 switch (get_mode()) {
 case PS2_KEYBOARD:
        printf("Error: Keyboard detected on PS/2 port\n");
   goto ErrorExit;
   break;
 case PS2_MOUSE:
       printf("Mouse Detected!\n");
       init();
    break;
 default:
   printf("Error: Unrecognized or no device on PS/2 port\n");
   goto ErrorExit;
 }
 
 printf("Ready!!!!\n");

 // Clear the payload
 for (curMsgChar=MAX_MSG_LENGTH-1; curMsgChar>0; curMsgChar--)
 {
   UDP_PACKET_PAYLOAD[curMsgChar] = 0;
 }

for (;;){
       
     capture_mouse(&user_x , &user_y);
 
     IOWR_VGA_DATA(VGA_BASE, 0, user_x+500);
     IOWR_VGA_DATA(VGA_BASE, 1, user_y); 
         
     UDP_PACKET_PAYLOAD[curMsgChar++]=user_x & 0xFF;
     UDP_PACKET_PAYLOAD[curMsgChar++]=user_y & 0xFF;
     UDP_PACKET_PAYLOAD[curMsgChar++]=(user_y>>8) & 0xFF;
     UDP_PACKET_PAYLOAD[curMsgChar] = 0; // Terminate the string
    
     packet_length = 8 + curMsgChar;
     transmit_buffer[UDP_PACKET_LENGTH_OFFSET] = packet_length >> 8;
     transmit_buffer[UDP_PACKET_LENGTH_OFFSET + 1] = packet_length & 0xff;
  
  
     // reset data
     for (curMsgChar=MAX_MSG_LENGTH-1; curMsgChar>0; curMsgChar--) {
       UDP_PACKET_PAYLOAD[curMsgChar] = 0;
     }
        
 }//end infinite loop  
  return 0;       
    ErrorExit:
        printf("Program terminated with error condition\n");
        exit(0);   
}
